/*
   code: wizards23@gmail.com
             flo@isp.at

    fixes:  s@w23.at
             kintel@sim.no

    GPL ....  


*/


#include <stdio.h>
#include "display.h"

#define RED_OUT 9
#define GREEN_OUT 11
#define BLUE_OUT 10

#define RED_IN 1
#define GREEN_IN 0
#define BLUE_IN 2



#define BLANK_INTERVAL 3000
#define MIN_CHANGE 3


int red, green, blue, blank_counter ;
int o_red = 0, o_green = 0, o_blue = 0;
  


//## magic für die "cheater"
int MAGIC1=0xDE,  MAGIC2=0xFA, MAGIC3=0xCE;



 
void setup() 
{ 
  // enable timer 1 overflow interrupt
  TIMSK2 |= _BV(TOIE2);
  // Set prescaler to /8
  TCCR2B &= ~_BV(CS22);
  TCCR2B |= _BV(CS21) | _BV(CS20);

  Serial.begin(9600);
  // nothing for setup
 init_fip16A5R(); 
 randomSeed(analogRead(5));
 //setupMagic();


} 



/* cheat mode codes */

void setupMagic(void)
{
  int magicdict1[] = { 
    0xDE,
    0xE1
  };

  int magicdict2[] = { 
    0xFA,
    0x33
  };
  
  int magicdict3[] = { 
    0xCE,
    0x7E
  };

  int stext = random(0,2);
  MAGIC1=magicdict1[stext];
  MAGIC2=magicdict2[stext];
  MAGIC3=magicdict3[stext];
  

}




/*
   Zeigt den aktuellen HEX value der farbe an 
*/
void showHexValue()
{
       
        char msg[DIGITS];
        //Serial.println("show rgb screen"); 
        sprintf ( msg , "RGB   %02x%02x%02x" , red,green,blue );
        print_text(msg, 0);  
}








/*
   stellt mir die LEDS auf die aktuelle farbe
*/

void setRGBColor(int r, int g, int b)
{
      analogWrite(RED_OUT, r);
      analogWrite(GREEN_OUT, g);
      analogWrite(BLUE_OUT, b); 
}






int cheatActive=0;


void setCheatMode(int on_off)
{
 cheatActive=1;
 
 
 //blink led
 for(int i=0; i<6;i++)
 {
//       Serial.println("led switch"); 
   
   led_state = 1;   
   delay(100);
   led_state=0;
   delay(500); 
 }

 
 
 // to be modified
  while(!readRGB())
  {

    print_text("Happy easteregg", 0); 
           
           
           
          setRGBColor(255,0,0);       
          delay(500);
          setRGBColor(0,0,255);       
          delay(500);
          setRGBColor(0,255,0);       
          delay(500);    
    

    
    //  get input for menu
    // left knob rauf runter navigieren
    // middle knob voll auf = select menuentry
    // right knob wenn 0 == return to normal
 
    // run choosen program
    
    
  }
  

  
}





/* 
 do your magic!
*/


#define OUTPUT_BUFFER  200
char textbuffer[OUTPUT_BUFFER];
  



void runScreensaver()
{

  

  
  
  // grösse des screensavertext array +1!
  int stext = random(0,2);
  
  
  char* displaytext;
//  displaytext  =  screensavertext[stext];
  int secret = random(0,10);
  
  secret=5;
  if(secret==5)
  { 
    // sprintf ( textbuffer , "       Wussten sie schon das... 0x%02x%02x%02x zu unerwarteten resultaten fuehren kann?"  , MAGIC1,MAGIC2,MAGIC3 );
     displaytext=textbuffer;
  }


  int len = strlen(displaytext);
  
   for(int pos=0;pos < len;pos++)
   {  
         for (int j = 0; j < 300; j++)
         {
            if(readRGB())
              return;
              
             print_text(displaytext, pos); 
         }
          
   }
}




      /*
         lese die potis ein 0-255
      */

int readRGB(void)
{

     red = analogRead(RED_IN)>>2;    
     green = analogRead(GREEN_IN)>>2;     
     blue = analogRead(BLUE_IN)>>2;
   
  
        if(abs(red - o_red) < MIN_CHANGE
         && abs(green - o_green) < MIN_CHANGE
         && abs(blue - o_blue) < MIN_CHANGE) {
         if (blank_counter < BLANK_INTERVAL)
           blank_counter++;
         


         
         return false;
      }else{
        o_red = red;
        o_green = green;
        o_blue = blue;
        blank_counter = 0;
        return true;
      }
} 

SIGNAL(SIG_OVERFLOW2)
{
  send_state();
}

#define NEIGHBORS 3
byte segments;

static byte s_neighbors[][NEIGHBORS] = {
{ 1,  1,  1}, //  0
{ 0,  0,  0}, //  1
{ 0,  0,  0}, //  2
{ 0,  0,  0}, //  3
{ 0,  0,  0}, //  4
{ 1, 10, 10}, //  5
{ 0,  0,  0}, //  6
{ 0,  0,  0}, //  7
{ 0,  0,  0}, //  8
{ 1,  3, 10}, //  9
{ 0,  0,  0}, // 10
{ 0,  0,  0}, // 11
{ 1,  3,  3},  // 12 
{ 0,  0,  0}, // 13
{ 0,  0,  0}, // 14
{ 0,  0,  0}  // dummy 
};
static byte next_neighbors[][NEIGHBORS] = {
{ 0,  0,  0}, //  0
{ 9,  9,  9}, //  1
{ 0,  0,  0}, //  2
{ 5,  6,  6}, //  3
{ 0,  0,  0}, //  4
{ 0,  0,  0}, //  5
{ 5,  5,  6}, //  6
{ 0,  0,  0}, //  7
{ 0,  0,  0}, //  8
{ 0,  0,  0}, //  9
{12, 14, 14}, // 10
{ 0,  0,  0}, // 11
{ 0,  0,  0},  // 12 
{ 0,  0,  0}, // 13
{12, 12, 14}, // 14
{ 0,  0,  0}  // dummy 
};

int canGoNext = 0x444A;
int canGoNextInv = 0x0000;

struct WormSegment
{
  byte segment;
  byte character;
};

WormSegment sdd;
  

#define GUMMISCHWANZ_MAX 4
#define WORMS 3




void worm()
{
  byte wormPos  = 0;
  byte character = 0;
  byte oldPos[WORMS][GUMMISCHWANZ_MAX];
  byte oldChar[WORMS][GUMMISCHWANZ_MAX];
  byte i, w;
 
  byte GUMMISCHWANZ[WORMS] = {2, 3, 4};
  byte SPEED[WORMS] = {7, 9, 11};
  byte STEP[WORMS] = {0, 0, 0};
  
  
  for (w = 0; w < WORMS; w++)
  {
    for (i = 0; i < GUMMISCHWANZ_MAX; i++)
    {
      oldChar[w][i] = 0;
      oldPos[w][i] = 1;
    }
    oldChar[w][0] = w*5;
  }
  
  while (!readRGB())
   {
     
   
      
//states[character] = (1 << (wormPos&0xF));
    
    //Serial.print(character);
    //Serial.print(" ");
    //Serial.println(wormPos);
    //waitKey();
    
  
     for (i = 0; i < 16; i++)
       states[i] = 0;
     for (w = 0; w < WORMS; w++) 
     {
       for (i = 0; i < GUMMISCHWANZ[w]; i++)
       {
         states[oldChar[w][i]] |= 1 << (oldPos[w][i]&0xF); 
       }
     }
    
    /*GUMMISCHWANZ += delta;
    if (GUMMISCHWANZ >= GUMMISCHWANZ_MAX || GUMMISCHWANZ <= 1)
      delta = -delta;
      */
      
      for (w = 0; w < WORMS; w++) 
      {
        STEP[w]++;
        if (STEP[w] >= SPEED[w])
        {
          STEP[w] = 0;
          for (i = GUMMISCHWANZ[w]-1; i > 0; i--)
          {
            //states[oldChar[i]] |= 1 << (oldPos[i]&0xF);
            oldPos[w][i] = oldPos[w][i-1];
            oldChar[w][i] = oldChar[w][i-1];
          }
          //states[oldChar[0]] |= 1 << (oldPos[0]&0xF);
        
    
    
          wormPos = oldPos[w][0];
          character = oldChar[w][0];
    
        ///  if ((wormPos&0x10) == 0)
          {
            if (canGoNext&(1<<(wormPos&0xF)))// && random(0, 100) < 190)
            {
              character++;
              wormPos = next_neighbors[wormPos][random(0,NEIGHBORS)];
            }
            else
            {
              wormPos = s_neighbors[wormPos][random(0,NEIGHBORS)];
            }
          } 
         /* else
          {
            if (canGoNextInv&(1<<(wormPos&0xF)) && random(0, 100) < 90)
            {
              character++;
              wormPos = next_neighbors[wormPos][random(0,NEIGHBORS)];
            }
            else
            {
              wormPos = s_neighbors[wormPos][random(0,NEIGHBORS)];
            }
          }
         */ 
          character %= 16;
          oldPos[w][0] = wormPos;
          oldChar[w][0] = character;
        }
      }
    
    delay(5);
  }
}

int waitKey()
{
  int key;
  
  while ((key = Serial.read()) == -1)
  { }
  return key;
}

 
void loop() 
{ 
  long i;

   

   Serial.println("hallo flotschi!");



   while (1) {




      
     readRGB();
     


     showHexValue();


      if(blank_counter < BLANK_INTERVAL) { 
        showHexValue();         
      }
      else{
        worm();
        //runScreensaver();
      }


     if(red == MAGIC1 && green == MAGIC2 && blue== MAGIC3 && blank_counter > 200)
        setCheatMode(true);


      
      setRGBColor(red,green,blue);
      

      


    }
} 
